#include <Wt/WApplication>
#include <Wt/WServer>

#include "PiecemealFeed.h"

using namespace Wt;

static const char *BlogUrl = "/blog/";
static const char *FeedUrl = "/blog/feed/";

WApplication *createApplication(const WEnvironment& env)
{
    return new WApplication(env);
}

int main(int, char ** args)
{
    try {
        const int argc = 5;
        char * argv[argc] = { *args, "--http-address=0.0.0.0", "--http-port=80", "--deploy-path=/", "--docroot=." };

        WServer server(argc, argv, WTHTTP_CONFIGURATION);

        PiecemealFeed rssFeed;

        server.addResource(&rssFeed, FeedUrl);
        server.addEntryPoint(EntryPointType::Application, createApplication, BlogUrl);
        server.run();

    } catch (WServer::Exception& e) {
        std::cerr << e.what() << std::endl;
    } catch (std::exception &e) {
        std::cerr << "exception: " << e.what() << std::endl;
    }
}
